{% extends '@EasyAdmin/default/layout.html.twig' %}

{% block content_title %}Prestashop orders{% endblock %}

{% block main %}
    <div class="modal fade" id="offline_product" style="z-index:1100;" tabindex="-1" role="dialog"
         aria-hidden="true">
        <div class="modal-dialog modal-xl" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Add Offline Product</h5>
                    <div class="form-group">
                        <div class="input-group">
                            <input autocomplete="off" type="text" list="offline_products"
                                   id="result_offline_products" data-orderid=""
                                   class="form-control"
                                   placeholder="Search for existing one"/>
                            <button type="button" id="add_offline_product" class="btn btn-success d-none"
                                    data-orderid="">Add offline product
                            </button>
                        </div>
                        <input type="hidden" id="offline_products_add">
                        <datalist id="offline_products"></datalist>
                    </div>

                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    {{ form_start(offlineProductForm, {'attr':{'id':'offlineProductForm'}}) }}
                    <div class="row">
                        <div class="col">
                            {{ form_row(offlineProductForm.name) }}
                        </div>
                        <div class="col">
                            {{ form_row(offlineProductForm.ean13) }}
                        </div>
                        <div class="col">
                            {{ form_row(offlineProductForm.isbn) }}
                        </div>

                    </div>
                    <div class="row">
                        <div class="col">
                            {{ form_row(offlineProductForm.quantity) }}
                        </div>
                        <div class="col">
                            {{ form_row(offlineProductForm.price) }}
                        </div>
                        <div class="col">
                            {{ form_row(offlineProductForm.wholesale_price) }}
                        </div>
                    </div>
                    <div class="row">
                        <div class="col">
                            {{ form_row(offlineProductForm.reference) }}
                        </div>
                        <div class="col">
                            {{ form_row(offlineProductForm.supplier_reference) }}
                        </div>
                        <div class="col">
                            {{ form_row(offlineProductForm.weight) }}
                        </div>
                    </div>
                    <div class="row">
                        <div class="col">
                            {{ form_row(offlineProductForm.upc) }}
                        </div>
                        <div class="col">
                            {{ form_row(offlineProductForm.manufacturer) }}
                        </div>
                        <div class="col">
                            {{ form_row(offlineProductForm.submit) }}
                        </div>
                    </div>
                    {{ form_row(offlineProductForm.supplier) }}
                    {{ form_row(offlineProductForm.order) }}

                    {{ form_end(offlineProductForm) }}
                </div>
            </div>
        </div>
    </div>


    <div class="row align-items-center">
        <div class="select_orders_list my-4 ml-3 col-5">
            <select id="selectSupplier" class="form-control">
                <option disabled selected>Select supplier</option>
                {% for supplier in suppliers %}
                    <option
                            {% if currentIdSupplier == supplier.id %} selected {% endif %}
                            value="{{ path('prestashop_order',{ supplier:supplier.id}) }}">{{ supplier.name }}</option>
                {% endfor %}
            </select>
        </div>


    </div>
    {% if currentIdSupplier != null %}

        <div class="mb-5">
            <div class="d-flex">
                <div class="load_today_orders_btn col-6">
                    <a href="{{ path("prestashop_orderLoad_today_orders",{"currentIdSupplier":currentIdSupplier}) }}"
                       class="btn btn-success">Load today orders</a>
                </div>
                Auto sending order
                <div class="checkbox-switch ml-2" data-propertyname="active">
                    <label for="is_auto_cron">
                        <input id="is_auto_cron" type="checkbox" {% if isAutoCron %}checked{% endif %}>
                        <span></span>
                    </label>
                </div>
            </div>
            <form id="dateForm" name="dateForm" class="flex-column">
                <div class="form-group d-flex flex-column flex-nowrap align-items-start w-75">
                    <label class="" for="inputDate">Please choose time to send daily order:</label>
                    <input id="time" type="time" value="{{ currentCronTime }}" class="form-control w-25" required>
                </div>
                <button class="ml-3 btn btn-success w-25" type="button" id="submitBTN">Set cron</button>
            </form>
            <script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.18.1/moment.min.js"></script>
            <script>
                let dateForm = document.querySelector('#dateForm')
                let checkbox = document.querySelector('#is_auto_cron')
                if (!checkbox.checked) dateForm.style.display = 'none'
                document.getElementById('is_auto_cron').addEventListener('click', (event) => {
                    let automated = +document.getElementById('is_auto_cron').checked;
                    let http = new XMLHttpRequest();
                    let host = window.location.hostname;
                    let changeRequest = "/setAutoCron/{{ currentIdSupplier }}/" + automated;
                    http.open('POST', changeRequest);
                    http.send();
                    if (checkbox.checked) {
                        dateForm.style.display = 'flex'
                    } else {
                        dateForm.style.display = 'none'
                    }

                })

                const link = "/setCronTime/{{ currentIdSupplier }}/"
                document.getElementById('submitBTN').addEventListener('click', (event) => {
                    console.log(document.getElementById('time').value);
                    let mom = moment(document.getElementById('time').value, 'hh:mm a').format('lll');
                    const date = new Date(mom);
                    const timestamp = date.getTime();
                    let form = document.forms.dateForm;
                    form.setAttribute('action', link + document.getElementById('time').value)
                    form.submit();

                })
            </script>
        </div>
    {% endif %}
    <table class="table datagrid">
        <thead>
        <tr>
            <th scope="col">
                <span>#</span>
            </th>
            <th scope="col">
                <span>Status</span>
            </th>
            <th scope="col">
                <span>Reference</span>
            </th>
            <th scope="col">
                <span>Delivery Address</span>
            </th>
            <th scope="col">
                <span>Invoice Address</span>
            </th>
            <th scope="col">
                <span>Date</span>
            </th>
            <th scope="col">
                <span>Price</span>
            </th>
            <th scope="col">
                <span>Details</span>
            </th>
        </tr>
        </thead>
        <tbody>
        {% for order in orders %}
            <tr>
                <td>
                    <span>{{ order.getId }}</span>
                </td>
                <td id="order_status_{{ order.id }}">
                    <span>{{ order.getStatusName }}</span>
                </td>
                <td>
                    <span>{{ order.getReference }}</span>
                </td>
                <td>
                    <select class="form-control select_address" data-order="{{ order.id }}">
                        <option disabled selected>Select delivery address</option>
                        {% for address in company_addresses %}
                            <option value="{{ address.id }}"
                                    {% if order.getCompanyAddress is not null and order.getCompanyAddress.getId == address.id %}
                                        selected
                                    {% endif %}
                                    class="select_address_option">{{ address.firstname }}</option>
                        {% endfor %}
                    </select>
                </td>
                <td>
                    <select class="form-control select_invoice_address" data-order="{{ order.id }}">
                        <option disabled selected>Select invoice address</option>
                        {% for address in company_addresses %}
                            <option value="{{ address.id }}"
                                    {% if order.getInvoiceAddress is not null and order.getInvoiceAddress.getId == address.id %}
                                        selected
                                    {% endif %}
                                    class="select_invoice_address_option">{{ address.firstname }}</option>
                        {% endfor %}
                    </select>
                </td>
                <td>
                    <span>{{ order.getDate|date('d/m/Y') }}</span>
                </td>
                <td>
                    <span>{{ order.getPrice }}</span>
                </td>
                <td>
                        <span>
                            <button type="button" class="btn btn-primary" data-toggle="modal"
                                    data-target="#table_{{ order.id }}">Products</button>
                            {% if order.getStatus == 1 %}
                                <button class="btn_validated btn btn-success mx-2" data-id="{{ order.id }}"
                                        type="button">Validated</button>
                            {% endif %}
                            {#                            {% if order.getStatus == 0 %}#}
                            {#                                <button type="button" class="btn btn-primary add-offline-product-button"#}
                            {#                                        data-toggle="modal" data-supplier="{{ order.supplier.id }}"#}
                            {#                                        data-target="#offline_product"#}
                            {#                                        data-orderid="{{ order.id }}">Add Offline Product</button>#}
                            {#                            {% endif %}#}
                        </span>
                    <div class="modal fade" id="table_{{ order.id }}" tabindex="-1" role="dialog" aria-hidden="true">
                        <div class="modal-dialog modal-xl" role="document">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <h5 class="modal-title">Products</h5>
                                    {% if order.getStatus == 0 %}
                                        <button type="button" class="btn btn-primary add-offline-product-button ml-3"
                                                data-toggle="modal" data-dismiss="modal"
                                                data-supplier="{{ order.supplier.id }}"
                                                data-target="#offline_product"
                                                data-orderid="{{ order.id }}">Add Offline Product
                                        </button>
                                    {% endif %}
                                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                        <span aria-hidden="true">&times;</span>
                                    </button>
                                </div>
                                <div class="modal-body">
                                    {% if order.status == 0 %}
                                        <div class="form-group">
                                            <div class="input-group">
                                                <input autocomplete="off" type="text" list="products_{{ order.id }}"
                                                       id="result_products_{{ order.id }}" data-orderid="{{ order.id }}"
                                                       data-supplier="{{ order.supplier.id }}"
                                                       class="form-control search_products"
                                                       placeholder="Search products"/>
                                                <button class="btn btn-success add_product_btn d-none"
                                                        data-orderid="{{ order.id }}">Add product
                                                </button>
                                            </div>
                                            <input type="hidden" id="products_{{ order.id }}_add">
                                            <datalist id="products_{{ order.id }}"></datalist>
                                        </div>
                                    {% endif %}
                                    <div class="product_table_container" data-orderid="{{ order.id }}">
                                        <table id="product_table_{{ order.id }}"
                                               class="table table-responsive product_table">
                                            <tr>
                                                <th>Product name</th>
                                                <th>Whole price</th>
                                                <th>Brand</th>
                                                <th>Reference</th>
                                                <th>Orders</th>
                                                <th>Ordered quantity</th>
                                                <th>Quantity validated</th>
                                            </tr>
                                            {% for orderDetails in order.getPrestashopOrderDetails %}
                                                {% set product = orderDetails.product?orderDetails.product:orderDetails.offlineProduct %}
                                                {% set class = orderDetails.product?"product":"offlineProduct" %}
                                                {% set quantity_validated_class = "d-none" %}
                                                {% if(orderDetails.getQuantityValidated == null and order.getStatus == 2) %}
                                                    {% set quantity_validated_class = "d-block" %}
                                                {% endif %}
                                                {% set quantity_ordered_class = "d-none" %}
                                                {% if(order.getStatus == 0) %}
                                                    {% set quantity_ordered_class = "d-block" %}
                                                {% endif %}
                                                <tr>
                                                    <td>{{ product.name }}</td>
                                                    <td>
                                                        {% if order.getStatus == 0 %}
                                                            <form class="change_wholesale_price_form">
                                                                <input type="text"
                                                                       class="wholesale_price_input w-100 form-control"
                                                                       data-id="{{ product.id }}"
                                                                       data-class="{{ class }}"
                                                                       value="{{ product.wholesalePrice }}">
                                                                <button type="submit"
                                                                        class="btn btn-success w-100 save_wholesale_price text-uppercase">
                                                                    Save
                                                                </button>
                                                            </form>
                                                        {% else %}
                                                            {{ product.wholesalePrice }}
                                                        {% endif %}
                                                    </td>
                                                    <td>
                                                        {% if product.manufacturer != null %}
                                                            {{ product.manufacturer.name }}
                                                        {% else %}
                                                            <span class="badge badge-warning">None brand</span>
                                                        {% endif %}
                                                    </td>
                                                    <td>{{ product.reference }}</td>
                                                    <td>{{ orderDetails.orders|join(',') }}</td>
                                                    <td class="change_quantity_ordered" data-id="{{ order.id }}">
                                                        <form class="change_quantity_ordered_form {{ quantity_ordered_class }}"
                                                              data-id="{{ orderDetails.id }}">
                                                            <input type="text"
                                                                   class="quantity_ordered_input w-100 form-control"
                                                                   data-id="{{ orderDetails.id }}"
                                                                   value="{{ orderDetails.getQuantity }}">
                                                            <button type="submit"
                                                                    class="btn btn-success w-100 save_quantity_ordered text-uppercase">
                                                                Save
                                                            </button>
                                                        </form>
                                                        {% if(order.getStatus != 0) %}
                                                            {{ orderDetails.getQuantity }}
                                                        {% endif %}

                                                    </td>


                                                    <td class="change_quantity_validated" data-id="{{ order.id }}">
                                                        <form class="change_quantity_validated_form {{ quantity_validated_class }}"
                                                              data-id="{{ orderDetails.id }}">
                                                            <input type="text"
                                                                   class="quantity_validated_input w-100 form-control"
                                                                   data-id="{{ orderDetails.id }}"
                                                                   value="{{ orderDetails.getQuantityValidated }}">
                                                            <button type="submit"
                                                                    class="btn btn-success w-100 save_quantity_validated text-uppercase">
                                                                Save
                                                            </button>
                                                        </form>
                                                        {% if(orderDetails.getQuantityValidated != null and order.getStatus == 2) %}
                                                            {{ orderDetails.getQuantityValidated }}
                                                        {% endif %}

                                                    </td>
                                                </tr>
                                            {% endfor %}
                                        </table>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                </td>

            </tr>
        {% endfor %}
        </tbody>
    </table>
    <script src="{{ asset('assets/js/functions/ajax.js') }}"></script>
    <script>
        function resetOfflineProductForm() {
            let form = document.getElementById('offlineProductForm');
            [...form.getElementsByClassName('form-control')].forEach((elem) => {
                elem.value = null;
                // console.log(elem.value);
            })
        }

        resetOfflineProductForm();
        document.querySelectorAll('.change_quantity_validated_form').forEach(item => {
            item.addEventListener('submit', e => {
                e.preventDefault();
                let isContinue = confirm('Are you sure?');
                if (isContinue) {
                    const id = e.target.dataset.id;
                    const quantityValidated = e.target.querySelector('.quantity_validated_input').value;

                    ajax('get', null, '/prestashop_order/update_quantity_validated/' + id + '/' + quantityValidated, null, (res) => {
                        item.innerHTML = quantityValidated;
                        console.log(res);
                    });
                }
            });
        });

        function sendOrderedQuantity() {
            document.querySelectorAll('.change_quantity_ordered_form').forEach(item => {
                item.addEventListener('submit', e => {
                    e.preventDefault();
                    let isContinue = confirm('Are you sure?');
                    if (isContinue) {
                        const id = e.target.dataset.id;
                        const quantityOrdered = e.target.querySelector('.quantity_ordered_input').value;

                        ajax('get', null, '/prestashop_order/update_quantity_ordered/' + id + '/' + quantityOrdered, null, (res) => {
                            // item.innerHTML = quantityOrdered;
                            console.log(res);
                        });
                    }
                });
            });
        }

        sendOrderedQuantity();

        const selectSupplier = document.getElementById('selectSupplier');
        selectSupplier.addEventListener('change', e => {
            const link = e.target.value;
            window.location.replace(link);
        });

        const validatedBtn = document.querySelectorAll('.btn_validated');
        validatedBtn.forEach(item => {
            item.addEventListener('click', e => {
                let isContinue = confirm('Are you sure?');

                if (isContinue) {
                    const orderId = item.dataset.id;
                    ajax('get', null, `/prestashop_order/validate_order/${orderId}`, null, (res) => {
                        if (res === 'Success') {
                            document.getElementById('order_status_' + orderId).innerHTML = '<span>validated</span>';
                            item.classList.add('d-none');
                            document.querySelector(`change_quantity_validated_${orderId}`);
                        }
                        item.closest('tbody').querySelectorAll('.change_quantity_validated[data-id="' + orderId + '"] form').forEach(item => {
                            item.classList.add('d-block');
                        })
                    });
                }

            });
        });

        const selectAddress = document.querySelectorAll('.select_address');
        selectAddress.forEach(item => {
            item.addEventListener('change', e => {
                const address = e.target.value;
                const order = e.target.closest('.select_address').dataset.order;

                ajax('get', null, '/prestashop_order/set_order_address/' + order + '?address=' + address, null, res => console.log(res))
            });
        });

        const selectInvoiceAddress = document.querySelectorAll('.select_invoice_address');
        selectInvoiceAddress.forEach(item => {
            item.addEventListener('change', e => {
                const address = e.target.value;
                const order = e.target.closest('.select_invoice_address').dataset.order;

                ajax('get', null, '/prestashop_order/set_order_invoice_address/' + order + '?address=' + address, null, res => console.log(res))
            });
        });

        let timeout = null;

        function search(orderId, supplier, value) {
            clearTimeout(timeout);
            timeout = setTimeout(() => {
                ajax('post', null, `/prestashop_order/search_products/${supplier}`, {
                    query: value
                }, res => {
                    const tableContainer = document.querySelector(`#products_${orderId}`);
                    tableContainer.innerHTML = res;
                });
            }, 300)
        }

        function searchOffline(value, supplier) {
            clearTimeout(timeout);
            timeout = setTimeout(() => {
                ajax('post', null, `/prestashop_order/search_offline_products/${supplier}`, {query: value}, res => {
                    const tableContainer = document.querySelector('#offline_products');
                    tableContainer.innerHTML = res;
                });
            }, 300)
        }

        document.querySelectorAll('.search_products').forEach(item => {
            item.addEventListener('change', e => {
                const orderId = e.target.dataset.orderid;
                let hiddenInput = document.getElementById(`products_${orderId}_add`);
                const addBtn = document.querySelector(`.add_product_btn[data-orderid="${orderId}"]`);

                if (hiddenInput.value === '' || !hiddenInput.value || hiddenInput.value === 'undefined') {
                    addBtn.classList.remove('d-block');
                    addBtn.classList.add('d-none');
                }
            });

            item.addEventListener('input', e => {
                const orderId = e.target.dataset.orderid;
                let option = document.querySelector('option[value="' + e.target.value + '"]');
                let hiddenInput = document.getElementById(`products_${orderId}_add`);
                const addBtn = document.querySelector(`.add_product_btn[data-orderid="${orderId}"]`);

                if (option) {
                    hiddenInput.value = option.dataset.value;
                } else {
                    hiddenInput.value = '';
                }

                if (e.target.value && e.target.value.trim().length !== 0) {
                    search(orderId, e.target.dataset.supplier, e.target.value);

                    if (hiddenInput.value === '' || !hiddenInput.value || hiddenInput.value === 'undefined') {
                        addBtn.classList.add('d-none');
                        addBtn.classList.remove('d-block');
                    } else {
                        addBtn.classList.remove('d-none');
                        addBtn.classList.add('d-block');
                    }
                }
            });
        });

        document.querySelectorAll('.add_product_btn').forEach(item => {
            item.addEventListener('click', function (e) {
                const orderId = e.target.dataset.orderid;
                const productId = document.getElementById(`products_${orderId}_add`).value;
                let hiddenInput = document.getElementById(`products_${orderId}_add`);
                ajax('get', null, `/prestashop_order/addProductToOrderDetails/${orderId}/${productId}`, null, res => {
                    let table = document.getElementById('product_table_' + orderId);
                    table.innerHTML += res;
                    sendOrderedQuantity();
                    changeOrderProductWholesalePrice();
                    document.querySelector('.search_products[data-orderid="' + orderId + '"]').value = '';
                    item.classList.remove('d-block');
                    item.classList.add('d-none');
                    const dataList = document.querySelector(`#products_${orderId}`);
                    dataList.innerHTML = '';
                    alert('Product successfully added');
                    hiddenInput.value = '';

                })
            });
        });

        document.querySelector('#result_offline_products').addEventListener('input', e => {
            const orderId = e.target.dataset.orderid;
            let option = document.querySelector('option[value="' + e.target.value + '"]');
            let hiddenInput = document.getElementById('offline_products_add');
            if (option) {
                hiddenInput.value = option.dataset.value;
                document.querySelector(`#add_offline_product`).classList.remove('d-none')
            }
            if (e.target.value.trim().length === 0) {
                document.querySelector(`#add_offline_product`).classList.add('d-none')
            }
            if (e.target.value && e.target.value.trim().length !== 0) {
                searchOffline(e.target.value, e.target.dataset.supplier);
            }
        });

        document.querySelector('#add_offline_product').addEventListener('click', function (e) {
            const orderId = e.target.dataset.orderid;
            const productId = document.getElementById('offline_products_add').value;
            ajax('get', null, `/prestashop_order/addOfflineProductToOrderDetails/${orderId}/${productId}`, null, res => {
                let table = document.getElementById('product_table_' + orderId);
                table.innerHTML += res;
                e.target.classList.remove('d-block');
                e.target.classList.add('d-none');
                const dataList = document.querySelector(`#offline_products`);
                dataList.innerHTML = '';
                const input = document.querySelector(`#result_offline_products`);
                input.value = '';
                document.getElementById('offline_products_add').value = '';
                alert('Product successfully added');
                sendOrderedQuantity();
            })
        });

        document.querySelectorAll('.add-offline-product-button').forEach(button => {
            button.addEventListener('click', e => {
                document.getElementById('offline_product_supplier').value = e.target.dataset.supplier;
                document.getElementById('offline_product_order').value = e.target.dataset.orderid;
                document.getElementById('add_offline_product').dataset.orderid = e.target.dataset.orderid;
                document.getElementById('result_offline_products').dataset.orderid = e.target.dataset.orderid;
                document.getElementById('result_offline_products').dataset.supplier = e.target.dataset.supplier;
            })
        });

        const changeOrderProductWholesalePrice = () => {
            document.querySelectorAll('.change_wholesale_price_form').forEach(item => {
                item.addEventListener('submit', e => {
                    e.preventDefault();
                    let input = e.target.querySelector('.wholesale_price_input');
                    const orderProductId = input.dataset.id;
                    const value = input.value;
                    const ent_class = input.dataset.class;
                    ajax('get', null, `/prestashop_order/change_product_wholesale_price/${orderProductId}/${value}/${ent_class}`, null, res => {
                        console.log(res);
                    });
                });
            });
        };
        changeOrderProductWholesalePrice();
    </script>
{% endblock %}
